Loading...
Searching...
No Matches
facet Class Reference

`#include <gfan.h>`

## Public Member Functions

| facet ()
| The default constructor.
| facet (const int &n)
| Constructor for lower dimensional faces.
| facet (const facet &f)
| The copy constructor.
facet * | shallowCopy (const facet &f)
| A shallow copy of facets.
void | shallowDelete ()
| ~facet ()
| The default destructor.
void | setFacetNormal (int64vec *iv)
| Comparison operator.
int64vec * | getFacetNormal () const
| Returns the facet normal.
const int64vec * | getRef2FacetNormal () const
| Return a reference to the facet normal.
void | printNormal () const
| Method to print the facet normal.
void | setFlipGB (ideal I)
| Store the flipped GB.
ideal | getFlipGB ()
| Return the flipped GB.
void | printFlipGB ()
| Print the flipped GB.
void | setUCN (int n)
| Set the UCN.
int | getUCN ()
| Get the UCN Returns the UCN iff this != NULL, else -1.
void | setInteriorPoint (int64vec *iv)
| Store an interior point of the facet.
int64vec * | getInteriorPoint ()
const int64vec * | getRef2InteriorPoint ()
volatile void | fDebugPrint ()
| Debugging function prints the facet normal an all (codim-2)-facets that belong to it.

## Data Fields

bool | isFlippable
| Boolean value to indicate whether a facet is flippable or not This is also used to mark facets that nominally are flippable but which do not intersect with the positive orthant.
facet * | next
facet * | prev
facet * | codim2Ptr
int | numCodim2Facets
unsigned | numRays
ring | flipRing

## Private Attributes

int64vec * | fNormal
| Inner normal of the facet, describing it uniquely up to isomorphism.
int64vec * | interiorPoint
| An interior point of the facet.
int | UCN
| Universal Cone Number The number of the cone the facet belongs to, Set in getConeNormals().
short | codim
| The codim of the facet.
ideal | flipGB
| The Groebner basis on the other side of a shared facet.

## Friends

class | gcone

## Detailed Description

Definition at line 46 of file gfan.h.

## Constructor & Destructor Documentation

## facet() [1/3]

facet::facet | ( |  | ) |

The default constructor.

## facet() [2/3]

facet::facet | ( | const int & | n | ) |

Constructor for lower dimensional faces.

## facet() [3/3]

facet::facet | ( | const facet & | f | ) |

The copy constructor.

## ~facet()

facet::~facet | ( |  | ) |

The default destructor.

## Member Function Documentation

## fDebugPrint()

volatile void facet::fDebugPrint | ( |  | ) |

Debugging function prints the facet normal an all (codim-2)-facets that belong to it.

## getFacetNormal()

int64vec * facet::getFacetNormal | ( |  | ) | const

inline

Returns the facet normal.

## getFlipGB()

ideal facet::getFlipGB | ( |  | ) |

inline

Return the flipped GB.

## getInteriorPoint()

int64vec * facet::getInteriorPoint | ( |  | ) |

inline

## getRef2FacetNormal()

const int64vec * facet::getRef2FacetNormal | ( |  | ) | const

inline

Return a reference to the facet normal.

## getRef2InteriorPoint()

const int64vec * facet::getRef2InteriorPoint | ( |  | ) |

inline

## getUCN()

int facet::getUCN | ( |  | ) |

inline

Get the UCN Returns the UCN iff this != NULL, else -1.

## printFlipGB()

void facet::printFlipGB | ( |  | ) |

inline

Print the flipped GB.

## printNormal()

void facet::printNormal | ( |  | ) | const

inline

Method to print the facet normal.

## setFacetNormal()

void facet::setFacetNormal | ( | int64vec * | iv | ) |

inline

Comparison operator.

Comparison of facets Stores the facet normal

Parameters

  int64vec |

## setFlipGB()

void facet::setFlipGB | ( | ideal | I | ) |

inline

Store the flipped GB.

## setInteriorPoint()

void facet::setInteriorPoint | ( | int64vec * | iv | ) |

inline

Store an interior point of the facet.

## setUCN()

void facet::setUCN | ( | int | n | ) |

inline

Set the UCN.

## shallowCopy()

facet * facet::shallowCopy | ( | const facet & | f | ) |

A shallow copy of facets.

## shallowDelete()

void facet::shallowDelete | ( |  | ) |

## Friends And Related Symbol Documentation

## gcone

friend class gcone

friend

Definition at line 131 of file gfan.h.

## Field Documentation

## codim

short facet::codim

private

The codim of the facet.

Definition at line 62 of file gfan.h.

## codim2Ptr

facet* facet::codim2Ptr

Definition at line 82 of file gfan.h.

## flipGB

ideal facet::flipGB

private

The Groebner basis on the other side of a shared facet.

In order not to have to compute the flipped GB twice we store the basis we already get when identifying search facets. Thus in the next step of the reverse search we can just copy the old cone and update the facet and the gcBasis. facet::flibGB is set via facet::setFlipGB() and printed via facet::printFlipGB

Definition at line 71 of file gfan.h.

## flipRing

ring facet::flipRing

Definition at line 85 of file gfan.h.

## fNormal

int64vec* facet::fNormal

private

Inner normal of the facet, describing it uniquely up to isomorphism.

Definition at line 50 of file gfan.h.

## interiorPoint

int64vec* facet::interiorPoint

private

An interior point of the facet.

Definition at line 53 of file gfan.h.

## isFlippable

bool facet::isFlippable

Boolean value to indicate whether a facet is flippable or not This is also used to mark facets that nominally are flippable but which do not intersect with the positive orthant.

This check is done in gcone::getCodim2Normals

Definition at line 78 of file gfan.h.

## next

facet* facet::next

Definition at line 80 of file gfan.h.

## numCodim2Facets

int facet::numCodim2Facets

Definition at line 83 of file gfan.h.

## numRays

unsigned facet::numRays

Definition at line 84 of file gfan.h.

## prev

facet* facet::prev

Definition at line 81 of file gfan.h.

## UCN

int facet::UCN

private

Universal Cone Number The number of the cone the facet belongs to, Set in getConeNormals().

Definition at line 58 of file gfan.h.

The documentation for this class was generated from the following file:

- Singular/dyn_modules/gfanlib/gfan.h